> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://reference.flatfile.com/api-reference/apps/create-constraint/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server. # Create constraint POST https://api.x.flatfile.com/v1/apps/{appId}/constraints Content-Type: application/json Creates a new constraint for an app Reference: https://reference.flatfile.com/api-reference/apps/create-constraint ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `appId` (string, required) — ID of the app ### Body (application/json) This endpoint expects a ConstraintCreate. - `description` (string, optional) - `function` (string, optional) - `options` (any, optional) - `label` (string, optional) - `validator` (string, optional) - `appId` (string, optional) — App ID ## Response ### 200 - `data` (ConstraintResource, required) ## Types ### ConstraintResource - `id` (string, required) — Constraint ID - `appId` (string, required) — App ID - `validator` (string, required) - `createdAt` (datetime, required) - `updatedAt` (datetime, required) - `description` (string, optional) - `function` (string, optional) - `options` (any, optional) - `label` (string, optional) ## Examples **Request** ```json {} ``` **Response** ```json { "data": { "id": "id", "appId": "appId", "validator": "validator", "createdAt": "2024-01-15T09:30:00Z", "updatedAt": "2024-01-15T09:30:00Z", "description": "description", "function": "function", "options": { "key": "value" }, "label": "label" } } ``` **SDK Code** ```python import requests url = "https://api.x.flatfile.com/v1/apps/appId/constraints" payload = {} headers = { "X-Disable-Hooks": "true", "Authorization": "Bearer ", "Content-Type": "application/json" } response = requests.post(url, json=payload, headers=headers) print(response.json()) ``` ```typescript import { FlatfileClient, Flatfile } from "@flatfile/api"; const client = new FlatfileClient({ token: "YOUR_TOKEN" }); await client.apps.createConstraint("appId", {}); ``` ```go package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.x.flatfile.com/v1/apps/appId/constraints" payload := strings.NewReader("{}") req, _ := http.NewRequest("POST", url, payload) req.Header.Add("X-Disable-Hooks", "true") req.Header.Add("Authorization", "Bearer ") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby require 'uri' require 'net/http' url = URI("https://api.x.flatfile.com/v1/apps/appId/constraints") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Post.new(url) request["X-Disable-Hooks"] = 'true' request["Authorization"] = 'Bearer ' request["Content-Type"] = 'application/json' request.body = "{}" response = http.request(request) puts response.read_body ``` ```java import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.post("https://api.x.flatfile.com/v1/apps/appId/constraints") .header("X-Disable-Hooks", "true") .header("Authorization", "Bearer ") .header("Content-Type", "application/json") .body("{}") .asString(); ``` ```php request('POST', 'https://api.x.flatfile.com/v1/apps/appId/constraints', [ 'body' => '{}', 'headers' => [ 'Authorization' => 'Bearer ', 'Content-Type' => 'application/json', 'X-Disable-Hooks' => 'true', ], ]); echo $response->getBody(); ``` ```csharp using RestSharp; var client = new RestClient("https://api.x.flatfile.com/v1/apps/appId/constraints"); var request = new RestRequest(Method.POST); request.AddHeader("X-Disable-Hooks", "true"); request.AddHeader("Authorization", "Bearer "); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ``` ```swift import Foundation let headers = [ "X-Disable-Hooks": "true", "Authorization": "Bearer ", "Content-Type": "application/json" ] let parameters = [] as [String : Any] let postData = JSONSerialization.data(withJSONObject: parameters, options: []) let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/apps/appId/constraints")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "POST" request.allHTTPHeaderFields = headers request.httpBody = postData as Data let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```